<?php

class ModelUserAuth extends Model {

    public function apply_user_auth_session($data = array()) {
        
        if(count($data['emails']) == 0){
            $emails=array();
            array_push($emails,$data['username']);
            
            if(!isset($data['customer'])){   
                $domain_name=explode('@',$data['username']);
                $profile=getAllDomains($domain_name[1]);

                $domains=explode(',',$profile);

                foreach($domains as $domain) {
                     array_push($emails,$domain_name[0].'@'.$domain);
                }
                
                if (($key = array_search($data['username'], $emails)) !== false) {
                    unset($emails[$key]);
                }
            }
            
            $data['emails'] = $emails;
        }
        
        $session = Registry::get('session');

        $session->set("username", $data['username']);
        $session->set("uid", $data['uid']);
        $session->set("admin_user", $data['admin_user']);
        $session->set("email", $data['username']);
        $session->set("domain", $data['domain']);
        $session->set("realname", $data['realname']);

	$session->set("admindomains", $data['admindomains']);
        $session->set("auditdomains", $data['auditdomains']);
        $session->set("emails", $data['emails']);

        $session->set("folders", $data['folders']);

        $session->set("customer", $data['customer']);
    }

    public function checkLogin($username = '', $password = '') {
        $session = Registry::get('session');
        $ok = 0;

        $imap_server = array();

        $data = array();

        $data['username'] = '';
        $data['uid'] = -1;
        $data['admin_user'] = 0;
        $data['email'] = '';
        $data['domain'] = '';
        $data['realname'] = '';
        $data['auditdomains'] = array();
        $data['emails'] = array();
        $data['folders'] = array();
        $data['customer'] = 0;

        if ($username == '' || $password == '') {
            return 0;
        }


        if (CUSTOM_PRE_AUTH_FUNCTION && function_exists(CUSTOM_PRE_AUTH_FUNCTION)) {
            call_user_func(CUSTOM_PRE_AUTH_FUNCTION, $username);
        }

        if (ENABLE_LDAP_AUTH == 1) {
            $ok = $this->checkLoginAgainstLDAP($username, $password, $data)[0];
            $ldap_mail1 = $this->checkLoginAgainstLDAP($username, $password, $data)[1]; 
			if($ok == 2)
			{
				$grace_period_expired=2;
			}
			else if($ok == 3)
			{
				syslog(LOG_INFO, "EMPLOYEE cannot login as he is not licensed");
				$employee_login_status=3;
			}
            if ($ok == 1) {
                if (CUSTOM_EMAIL_QUERY_FUNCTION && function_exists(CUSTOM_EMAIL_QUERY_FUNCTION)) {
                    call_user_func(CUSTOM_EMAIL_QUERY_FUNCTION, $ldap_mail1);
                }

                return $ok;
            }
        }

        if (ENABLE_IMAP_AUTH == 1) {
            require 'Zend/Mail/Protocol/Imap.php';

            if (!isset($imap_server['IMAP_HOST'])) {
                $imap_server['IMAP_HOST'] = IMAP_HOST;
            }
            if (!isset($imap_server['IMAP_PORT'])) {
                $imap_server['IMAP_PORT'] = IMAP_PORT;
            }
            if (!isset($imap_server['IMAP_SSL'])) {
                $imap_server['IMAP_SSL'] = IMAP_SSL;
            }

            $ok = $this->checkLoginAgainstIMAP($imap_server, $username, $password, $data);

            if ($ok == 1) {
                if (CUSTOM_EMAIL_QUERY_FUNCTION && function_exists(CUSTOM_EMAIL_QUERY_FUNCTION)) {
                    call_user_func(CUSTOM_EMAIL_QUERY_FUNCTION, $username);
                }

                return $ok;
            }
        }

        if (ENABLE_POP3_AUTH == 1) {
            require 'Zend/Mail/Protocol/Pop3.php';
            $ok = $this->checkLoginAgainstPOP3($username, $password, $data);

            if ($ok == 1) {
                if (CUSTOM_EMAIL_QUERY_FUNCTION && function_exists(CUSTOM_EMAIL_QUERY_FUNCTION)) {
                    call_user_func(CUSTOM_EMAIL_QUERY_FUNCTION, $username);
                }

                return $ok;
            }
        }

        // fallback local auth
        $query = $this->db->query("SELECT u.username, u.uid, u.realname, u.dn, u.password, u.isadmin, u.domain, u.customer FROM " . TABLE_USER . " u, " . TABLE_EMAIL . " e WHERE e.email=? AND e.uid=u.uid", array($username));
		$query1 = $this->db->query("SELECT status FROM " . TABLE_USER . "  WHERE uid=? ", array($query->row['uid']));
		if(isset($query1->row['status']) && $query1->row['status']==0)
		{
			return -1;
		}
		$statusOfProfile= $this->db->query("SELECT is_deleted FROM ".TABLE_CUSTOMERS." WHERE id=".$query->row['customer']); //This is to find out whether the profile is active or not.
		
	if($statusOfProfile->row['is_deleted'] == 1)
	    return 0;

        if (!isset($query->row['password'])) {
			syslog(LOG_INFO, "Entered because no pwd in the user table");
			if($grace_period_expired == 2)
		    {
				syslog(LOG_INFO, "Employee cannot login because the profile's graceperiod has expired");
			    return 2;
		    }
		    else if($employee_login_status == 3)
		    {
				syslog(LOG_INFO, "Employee cannot login because he is not licensed");
			    return 3;
		    }
                return 0;
        }

        $pass = crypt($password, $query->row['password']);

        if ($pass == $query->row['password']) {
            $ok = 1;
		 $session->set("logged_user_is_ldap", "0");
            AUDIT(ACTION_LOGIN, $username, '', '', 'successful auth against user table');
        } else {
            AUDIT(ACTION_LOGIN_FAILED, $username, '', '', 'failed auth against user table');
        }


        if ($ok == 1) {
            $data['username'] = $username;
            $data['uid'] = $query->row['uid'];
            $data['admin_user'] = $query->row['isadmin'];
            $data['email'] = $username;
            $data['domain'] = $query->row['domain'];
            $data['realname'] = $query->row['realname'];
            $data['customer'] = $query->row['customer'];
			
            $data['auditdomains'] = $this->model_user_user->get_users_all_domains($query->row['uid']);
	    $data['admindomains'] = $this->model_user_user->get_admindomains_by_uid($query->row['uid']);

            if (CUSTOM_EMAIL_QUERY_FUNCTION && function_exists(CUSTOM_EMAIL_QUERY_FUNCTION)) {
                call_user_func(CUSTOM_EMAIL_QUERY_FUNCTION, $username);
            } else {
                $data['emails'] = $this->model_user_user->get_users_all_email_addresses($query->row['uid']);
            }

            $extra_emails = $this->model_user_user->get_email_addresses_from_groups($data['emails']);
            $data['emails'] = array_merge($data['emails'], $extra_emails);

            $data['folders'] = $this->model_folder_folder->get_folder_id_array_for_user($query->row['uid'], $data['admin_user']);

            $session->set("auth_data", $data);

            $this->is_ga_code_needed($username);

            $this->is_four_eye_auth_needed($data['admin_user']);

            return 1;
        }
		if($grace_period_expired == 2)
		{
		    syslog(LOG_INFO, "Employee cannot login because the profile's graceperiod has expired");
			return 2;
		}
		else if($employee_login_status == 3)
		{
			syslog(LOG_INFO, "Employee cannot login because he is not licensed");
			return 3;
		}

        return 0;
    }

    private function checkLoginAgainstLDAP($username = '', $password = '', $data = array()) {
        $a = array();
        $ret = 0;
		$isHostedService = isHostedService();
        if (ENABLE_SAAS == 1) {
            $params = $this->model_saas_ldap->get_ldap_params_by_email($username);
					if(LICENSE_STATUS <> 'TRIAL_PERIOD' && $isHostedService==0)
					{
					   list($l, $d) = explode("@", $username);
					   $current_date=date("m-d-Y");
					   $date = DateTime::createFromFormat("m-d-Y",$current_date);
					   $current_date = $date->format("Y-m-d");
					   syslog(LOG_INFO, "Verifying whether the domain of the user has unlicensed count and also the domain is ".$d);
					   $query=$this->db->query("SELECT id,domains,profile_grace_period_end_date from customers WHERE domains LIKE '%$d%' and profile_grace_period_end_date NOT IN('0000-00-00','NULL') and profile_grace_period_end_date < ? and is_deleted=?",array($current_date,0));
					   syslog(LOG_INFO, "Query is completed" . $query->num_rows);
					   if($query->num_rows > 0)
					   {
						   syslog(LOG_INFO, "Return called" . $query->row['domains']);
						   $ret=2;
						   return array($ret);
					   }
					}
            foreach ($params as $param) {
                $ret = $this->checkLoginAgainstLDAP_real($username, $password, $data, $param)[0];
				if(LICENSE_STATUS <> 'TRIAL_PERIOD' && $ret!=0)
			    {
			          syslog(LOG_INFO, "Checking the license of the employee");
				  $query=$this->db->query("SELECT is_licensed FROM smtp_senders WHERE sender_address='".$this->checkLoginAgainstLDAP_real($username, $password, $data, $param)[1]."'");
				  if($query->row['is_licensed']!=1){
                    $ret = 3;
                    return array($ret);
 			}
      			}
                syslog(LOG_INFO, "ldap auth result against " . $param['ldap_host'] . " / " . $param['ldap_type'] . ": $ret");

                if ($ret == 1) {
                    $success = 1;
                    $ldap_mail = $this->checkLoginAgainstLDAP_real($username, $password, $data, $param)[1];
                    return array($success,$ldap_mail);
                }
            }
        } else {
            $ret = $this->checkLoginAgainstLDAP_real($username, $password, $data)[0];
        }

        return array($ret);
    }

    private function checkLoginAgainstLDAP_real($username = '', $password = '', $data = array(), $a = array()) {
        $session = Registry::get('session');
                
        $query = $this->db->query("SELECT is_ldap_enable FROM " . TABLE_LDAPL_SETTING . " WHERE customer_id=?", array($a['customer']));
        
        if(isset($query->row['is_ldap_enable']) && $query->row['is_ldap_enable'] == 1) { 
            $ldap_type = '';
            $ldap_host = LDAP_HOST;
            $ldap_base_dn = LDAP_BASE_DN;
            $ldap_helper_dn = LDAP_HELPER_DN;
            $ldap_helper_password = LDAP_HELPER_PASSWORD;
            $ldap_auditor_member_dn = LDAP_AUDITOR_MEMBER_DN;
            $ldap_admin_member_dn = LDAP_ADMIN_MEMBER_DN;

            $role = 0;
            $username_prefix = '';

            if (count($a) >= 6) {
                $ldap_type = $a['ldap_type'];
                $ldap_host = $a['ldap_host'];
                $ldap_base_dn = $a['ldap_base_dn'];
                $ldap_helper_dn = $a['ldap_bind_dn'];
                $ldap_helper_password = $a['ldap_bind_pw'];
                $ldap_auditor_member_dn = $a['ldap_auditor_member_dn'];

                $ldap_mail_attr = $a['ldap_mail_attr'];
                $ldap_account_objectclass = $a['ldap_account_objectclass'];
                $ldap_distributionlist_attr = $a['ldap_distributionlist_attr'];
                $ldap_distributionlist_objectclass = $a['ldap_distributionlist_objectclass'];
            }

            if ($ldap_type != LDAP_TYPE_GENERIC) {
                list($ldap_mail_attr, $ldap_account_objectclass, $ldap_distributionlist_attr, $ldap_distributionlist_objectclass) = get_ldap_attribute_names($ldap_type);
            }

            if ($ldap_mail_attr == 'proxyAddresses') {
                $username_prefix = 'smtp:';
            }

            if ($ldap_host == '' || $ldap_helper_password == '') {
                return 0;
            }

            // connect to ldap server
            $ldapconn = ldap_connect($a['ldap_host'])
            or die("Could not connect to LDAP server.");

            if ($ldapconn) {
                // binding to ldap server
                $ldapbind = ldap_bind($ldapconn, $username, $password);
                // verify binding
                if ($ldapbind) {
                   
                    $role=0;
                    $emails = $username;
                    $primary_email="";
		    $proxy=array();	                 
                       
                    $ldaptree = split(";",$ldap_base_dn);
                    for($j=0;$j<sizeof($ldaptree);$j++){
                    //$ldaptree = $ldap_base_dn;
                    $filter="(userprincipalname=$username)";
                    $justthese = array("ou", "sn", "givenname", "mail");

                    $sr=ldap_search($ldapconn, $ldaptree[$j], $filter);

                    $info = ldap_get_entries($ldapconn, $sr);
                    //print_r($info["count"]);exit;
                    for ($i=0; $i<$info["count"]; $i++) {
                        $primary_email=$info[$i]["mail"][0];
			$proxy=$info[$i]["proxyaddresses"];
                        if(isset($primary_email) && $primary_email != "") goto CON;
                    }
                    }
CON:               if(isset($primary_email) && $primary_email == ""){
                        return 0;
                        AUDIT(ACTION_LOGIN_FAILED, $username, '', '', 'failed auth against LDAP');
                    }
                    
                    $extra_emails = $this->model_user_user->get_email_addresses_from_groups($emails);
                    array_push($extra_emails,$emails);
                    array_push($extra_emails,$primary_email);

                    for($k=0; $k<count($proxy) - 1; $k++)
                    {
                       $proxy[$k]=str_replace("smtp:","",$proxy[$k]);
                       $proxy[$k]=str_replace("SMTP:","",$proxy[$k]);
                       array_push($extra_emails,$proxy[$k]);
                    }

                    $data = $this->fix_user_data($a['cn'], $primary_email, $extra_emails, $role);
                                        
                    $session->set("auth_type", 'ldap');
                    $session->set("auth_data", $data);

                    $this->is_ga_code_needed($username);

                    $this->is_four_eye_auth_needed($role);

                    AUDIT(ACTION_LOGIN, $username, '', '', 'successful auth against LDAP');
                    $success = 1;
					$session->set("logged_user_is_ldap", "1");
                    return array($success,$primary_email);
                } else {
                    AUDIT(ACTION_LOGIN_FAILED, $username, '', '', 'failed auth against LDAP');
                }
            }
            
        }    
        
        //$ldap = new LDAP($ldap_host, $ldap_helper_dn, $ldap_helper_password);
        /*if ($ldap->is_bind_ok()) {

            $query = $ldap->query($ldap_base_dn, "(&(objectClass=$ldap_account_objectclass)($ldap_mail_attr=$username_prefix$username))", array());

            if (isset($query->row['dn']) && $query->row['dn']) {
                $a = $query->row;

                $ldap_auth = new LDAP($ldap_host, $a['dn'], $password);

                if (ENABLE_SYSLOG == 1) {
                    syslog(LOG_INFO, "ldap auth against '" . $ldap_host . "', dn: '" . $a['dn'] . "', result: " . $ldap_auth->is_bind_ok());
                }

                if ($ldap_auth->is_bind_ok()) {

                    $a['dn'] = stripslashes($a['dn']);
                    $a['dn'] = preg_replace("/\(/", '\(', $a['dn']);
                    $a['dn'] = preg_replace("/\)/", '\)', $a['dn']);

                    $query = $ldap->query($ldap_base_dn, "(|(&(objectClass=$ldap_account_objectclass)($ldap_mail_attr=$username_prefix$username))(&(objectClass=$ldap_distributionlist_objectclass)($ldap_distributionlist_attr=$username_prefix$username)" . ")(&(objectClass=$ldap_distributionlist_objectclass)($ldap_distributionlist_attr=" . $a['dn'] . ")))", array());

                    if ($this->check_ldap_membership($ldap_auditor_member_dn, $query->rows) == 1) {
                        $role = 2;
                    }
                    if ($this->check_ldap_membership($ldap_admin_member_dn, $query->rows) == 1) {
                        $role = 1;
                    }

                    $emails = $this->get_email_array_from_ldap_attr($query->rows);

                    $extra_emails = $this->model_user_user->get_email_addresses_from_groups($emails);
                    $emails = array_merge($emails, $extra_emails);

                    $data = $this->fix_user_data($a['cn'], $username, $emails, $role);

                    $session->set("auth_data", $data);

                    $this->is_ga_code_needed($username);

                    $this->is_four_eye_auth_needed($role);

                    AUDIT(ACTION_LOGIN, $username, '', '', 'successful auth against LDAP');

                    return 1;
                } else {
                    AUDIT(ACTION_LOGIN_FAILED, $username, '', '', 'failed auth against LDAP');
                }
            }
        } else if (ENABLE_SYSLOG == 1) {
            syslog(LOG_INFO, "cannot bind to '" . $ldap_host . "' as '" . $ldap_helper_dn . "'");
        }*/

        return 0;
    }

    private function check_ldap_membership($ldap_auditor_member_dn = '', $e = array()) {
        if ($ldap_auditor_member_dn == '') {
            return 0;
        }

        foreach ($e as $a) {
            foreach (array("memberof", "dn") as $memberattr) {
                if (isset($a[$memberattr])) {

                    if (isset($a[$memberattr]['count']) && $a[$memberattr]['count'] > 0) {

                        for ($i = 0; $i < $a[$memberattr]['count']; $i++) {
                            if ($a[$memberattr][$i] == $ldap_auditor_member_dn) {
                                return 1;
                            }
                        }
                    } else {
                        if ($a[$memberattr] == $ldap_auditor_member_dn) {
                            return 1;
                        }
                    }
                }
            }
        }

        return 0;
    }

    public function get_email_array_from_ldap_attr($e = array()) {
        $data = array();

        foreach ($e as $a) {
            //syslog(LOG_INFO, "checking ldap entry dn: " . $a['dn'] . ", cn: " . $a['cn']);

            foreach (array("mail", "mailalternateaddress", "proxyaddresses", "zimbraMailForwardingAddress", "member", "memberOfGroup") as $mailattr) {
                if (isset($a[$mailattr])) {

                    if (is_array($a[$mailattr])) {
                        for ($i = 0; $i < $a[$mailattr]['count']; $i++) {

                            //syslog(LOG_INFO, "checking entry: " . $a[$mailattr][$i]);

                            $a[$mailattr][$i] = strtolower($a[$mailattr][$i]);

                            if (strchr($a[$mailattr][$i], '@')) {

                                if (preg_match("/^([\w]+)\:/i", $a[$mailattr][$i], $p)) {
                                    if (isset($p[0]) && $p[0] != "smtp:") {
                                        continue;
                                    }
                                }

                                $email = preg_replace("/^([\w]+)\:/i", "", $a[$mailattr][$i]);
                                if (validemail($email) && !in_array($email, $data)) {
                                    array_push($data, $email);
                                }
                            }
                        }
                    } else {
                        //syslog(LOG_INFO, "checking entry #2: " . $a[$mailattr]);

                        $email = strtolower(preg_replace("/^([\w]+)\:/i", "", $a[$mailattr]));
                        if (validemail($email) && !in_array($email, $data)) {
                            array_push($data, $email);
                        }
                    }
                }
            }
        }

        return $data;
    }

    private function fix_user_data($name = '', $email = '', $emails = array(), $role = 0) {
        $data = array();

        $data['username'] = $email;
        $data['uid'] = -1;
        $data['admin_user'] = $role;
        $data['email'] = $email;
        $data['domain'] = '';
        $data['realname'] = $name;
        $data['auditdomains'] = $this->model_domain_domain->get_your_all_domains_by_email($email);
        $data['emails'] = $emails;
        $data['folders'] = array();

        $uid = $this->model_user_user->get_uid_by_email($email);
        if ($uid < 1) {
            $uid = $this->model_user_user->get_next_uid(TABLE_EMAIL);
            $query = $this->db->query("INSERT INTO " . TABLE_EMAIL . " (uid, email) VALUES(?,?)", array($uid, $email));
        }

        $data['uid'] = $uid;

        $a = explode("@", $email);
        $data['domain'] = $a[1];

        return $data;
    }

    private function checkLoginAgainstIMAP($imap_server = array(), $username = '', $password = '', $data = array()) {
        $session = Registry::get('session');
        $emails = array($username);

        if (!strchr($username, '@')) {
            return 0;
        }

        $login = $username;

        if (STRIP_DOMAIN_NAME_FROM_USERNAME == 1) {
            $a = explode("@", $username);
            $login = $a[0];
        }

        $imap = new Zend_Mail_Protocol_Imap($imap_server['IMAP_HOST'], $imap_server['IMAP_PORT'], $imap_server['IMAP_SSL']);
        if ($imap->login($login, $password)) {
            $imap->logout();

            $extra_emails = $this->model_user_user->get_email_addresses_from_groups($emails);
            $emails = array_merge($emails, $extra_emails);

            $data['username'] = $username;
            $data['email'] = $username;
            $data['emails'] = $emails;
            $data['role'] = 0;

            $data = $this->fix_user_data($username, $username, $emails, 0);

            $this->is_ga_code_needed($username);

            $session->set("auth_data", $data);

            $session->set("password", $password);

            return 1;
        }

        return 0;
    }

    private function checkLoginAgainstPOP3($username = '', $password = '', $data = array()) {
        $rc = 0;
        $emails = array($username);

        try {
            $conn = new Zend_Mail_Protocol_Pop3(POP3_HOST, POP3_PORT, POP3_SSL);

            if ($conn) {
                $s = $conn->connect(POP3_HOST);

                if ($s) {

                    try {
                        $conn->login($username, $password);

                        $extra_emails = $this->model_user_user->get_email_addresses_from_groups($emails);
                        $emails = array_merge($emails, $extra_emails);

                        $data = $this->fix_user_data($username, $username, $emails, 0);

                        $this->is_ga_code_needed($username);

                        $session = Registry::get('session');
                        $session->set("auth_data", $data);

                        $rc = 1;
                    } catch (Zend_Mail_Protocol_Exception $e) {
                        
                    }
                }
            }
        } catch (Zend_Mail_Protocol_Exception $e) {
            
        }

        return $rc;
    }

    public function check_ntlm_auth() {
        $ldap_auditor_member_dn = LDAP_AUDITOR_MEMBER_DN;
        $ldap_admin_member_dn = LDAP_ADMIN_MEMBER_DN;

        $role = 0;

        if (!isset($_SERVER['REMOTE_USER']) || $_SERVER['REMOTE_USER'] == '') {
            return 0;
        }

        $u = explode("\\", $_SERVER['REMOTE_USER']);

        if (isset($u[1])) {
            $username = $u[1];
        } else {
            $username = $_SERVER['REMOTE_USER'];
        }

        if (ENABLE_SYSLOG == 1) {
            syslog(LOG_INFO, "sso login: $username");
        }

        $ldap = new LDAP(LDAP_HOST, LDAP_HELPER_DN, LDAP_HELPER_PASSWORD);

        if ($ldap->is_bind_ok()) {

            $query = $ldap->query(LDAP_BASE_DN, "(&(objectClass=user)(samaccountname=" . $username . "))", array());

            if (isset($query->row['dn'])) {
                $a = $query->row;

                if (is_array($a['mail'])) {
                    $username = $a['mail'][0];
                } else {
                    $username = $a['mail'];
                }
                $username = strtolower(preg_replace("/^smtp\:/i", "", $username));

                if ($username == '') {
                    syslog(LOG_INFO, "no email address found for " . $a['dn']);
                    return 0;
                }

                $ldap_mail_attr = LDAP_MAIL_ATTR;
                if (LDAP_MAIL_ATTR == 'proxyAddresses') {
                    $ldap_mail_attr = 'proxyAddresses=smtp:';
                }

                $query = $ldap->query(LDAP_BASE_DN, "(|(&(objectClass=user)(" . $ldap_mail_attr . "$username))(&(objectClass=group)(member=$username))(&(objectClass=group)(member=" . stripslashes($a['dn']) . ")))", array());


                $emails = $this->get_email_array_from_ldap_attr($query->rows);

                $extra_emails = $this->model_user_user->get_email_addresses_from_groups($emails);
                $emails = array_merge($emails, $extra_emails);

                if (!in_array($username, $emails)) {
                    array_push($emails, $username);
                }

                if ($this->check_ldap_membership($ldap_auditor_member_dn, $query->rows) == 1) {
                    $role = 2;
                }
                if ($this->check_ldap_membership($ldap_admin_member_dn, $query->rows) == 1) {
                    $role = 1;
                }

                $data = $this->fix_user_data($a['cn'], $username, $emails, $role);
                $this->apply_user_auth_session($data);

                $this->model_user_prefs->get_user_preferences($username);

                AUDIT(ACTION_LOGIN, $username, '', '', 'successful auth against LDAP');

                return 1;
            }
        }

        return 0;
    }

    public function get_failed_login_count() {
        $session = Registry::get('session');

        $n = $session->get('failed_logins');
        if ($n == '') {
            $n = 0;
        }

        return $n;
    }

    public function increment_failed_login_count($n = 0) {
        $session = Registry::get('session');

        $n = $session->get('failed_logins') + 1;
        $session->set('failed_logins', $n);
    }

    private function is_ga_code_needed($username = '') {
        $session = Registry::get('session');

        $query = $this->db->query("SELECT ga_enabled FROM " . TABLE_USER_SETTINGS . " WHERE username=?", array($username));

        if (isset($query->row['ga_enabled']) && $query->row['ga_enabled'] == 1) {
            $session->set("ga_block", 1);
        }
    }

    public function is_four_eye_auth_needed($admin_user = 0) {
        $session = Registry::get('session');

        if (1 == FOUR_EYES_LOGIN_FOR_AUDITOR && 2 == $admin_user) {
            $session->set("four_eyes", 1);
        }
    }

    public function change_password($username = '', $password = '') {
        if ($username == "" || $password == "") {
            return 0;
        }

        $query = $this->db->query("UPDATE " . TABLE_USER . " SET password=? WHERE uid=?", array(crypt($password), $username));

        $rc = $this->db->countAffected();

        return $rc;
    }

    public function change_profile_pic($username = '', $file_real_name = '') {

        if ($username == "" || $file_real_name == "") {
            return 0;
        }

        $query = $this->db->query("UPDATE " . TABLE_USER . " SET profile_image=? WHERE uid=?", array($file_real_name, $username));

        $rc = $this->db->countAffected();

        return $rc;
    }
    
    public function change_company_logo($file_real_name = '') {

        if ($file_real_name == "") {
            return 0;
        }

        $query = $this->db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET company_logo=? WHERE id=?", array($file_real_name, 1));

        $rc = $this->db->countAffected();

        return $rc;
    }

    public function get_profile_pic($username) {
        $query = $this->db->query("SELECT profile_image FROM " . TABLE_USER . " WHERE uid=?", array($username));

        return $query->row['profile_image'];
    }
    
    public function get_company_logo($username) {
        $query = $this->db->query("SELECT company_logo,company_name,set_default FROM " . TABLE_GLOBAL_SETTINGS . " WHERE id=?", array($username));
        return $query->row;
    }
    public function change_company_name($organization_name = '',$set_default) {
        $query = $this->db->query("UPDATE " . TABLE_GLOBAL_SETTINGS . " SET company_name=?, set_default=? WHERE id=?", array($organization_name,$set_default,1));

        $rc = $this->db->countAffected();

        return $rc;
    }
    public function checkUser($email){
        $query = $this->db->query("SELECT count(u.uid) as counter,u.uid as user_id,u.realname as username,u.customer as customer FROM " . TABLE_USER . " u, " . TABLE_EMAIL . " e WHERE e.email=? AND e.uid=u.uid ", array($email));
        $data=array();
        
        if(isset($query->rows[0]['counter']) && $query->rows[0]['counter'] > 0){
            $data['user_id']=$query->rows[0]['user_id'];
            $data['username']=$query->rows[0]['username'];
            $data['customer']=$query->rows[0]['customer'];
        }
        
        return $data;
    }
    public function updateCode($uid,$code){
        $query = $this->db->query("UPDATE " . TABLE_USER . " SET verification_code=? WHERE uid=?", array($code, $uid));
    }
    public function checkUserRequest($code, $uid){
        $query = $this->db->query("Select count(uid) as counter from " . TABLE_USER . " WHERE verification_code=? and uid=?", array($code, $uid));
        
        if(isset($query->rows[0]['counter']) && $query->rows[0]['counter'] > 0){
            return TRUE;
        }
        
        return FALSE;
    }
    public function getAuthentication($username = '', $password = ''){
	
        $isHostedService = isHostedService();
        if ($username == '' || $password == '') {
            $return_data['primary_email']=$username;
            $return_data['status']=FALSE;
            $return_data['login_type']='local';
            
            return $return_data;
        }
        
               
        if (ENABLE_LDAP_AUTH == 1) {
            $params = $this->model_saas_ldap->get_ldap_params_by_email($username);
            foreach ($params as $param) {
               $ret = $this->checkLoginAgainstLDAP_outlook($username, $password, $data, $param);
            }
        }
        
        
        if(isset($ret['status']) && $ret['status'] ==  TRUE){
			if(LICENSE_STATUS <> 'TRIAL_PERIOD' )
			{
				$return_data['primary_email']=$username;
                $return_data['status']=FALSE;
                $return_data['login_type']='local';
				$return_data['reason']=0;
			   list($l, $d) = explode("@", $username);
			   $current_date=date("m-d-Y");
	           $date = DateTime::createFromFormat("m-d-Y",$current_date);
	           $current_date = $date->format("Y-m-d");

                   if(LICENSE_STATUS == 'TRIAL_EXPIRED')
                     {
                        $return_data['reason']=4;
                        $return_data['status']=FALSE;
                        syslog(LOG_INFO, "Trial period has expired so returning false for outlook plugin".$ret['status']);
                        return $return_data;
                     }

                if(LICENSE_STATUS == 'GRACE_PERIOD_EXPIRED')
                     {
                        $return_data['reason']=5;
                        $return_data['status']=FALSE;
                        syslog(LOG_INFO, "Grace Period has so returning false for outlook plugin".$ret['status']);
                        return $return_data;
                     }

                if(LICENSE_STATUS == 'EXTEND_TRIAL_PERIOD_GRACE_PERIOD_EXPIRED')
                     {
                        $return_data['reason']=6;
                        $return_data['status']=FALSE;
                        syslog(LOG_INFO, "Extend Trial Period has expired so returning false for outlook plugin".$ret['status']);
                        return $return_data;
                     }

			   syslog(LOG_INFO, "Login for outlook plugin and verifying whether the domain of the user has unlicensed count and also the domain is ".$d);
			   $query=$this->db->query("SELECT id,domains,profile_grace_period_end_date from customers WHERE domains LIKE '%$d%' and profile_grace_period_end_date NOT IN('0000-00-00','NULL') and profile_grace_period_end_date < ? and is_deleted=?",array($current_date,0));
			   syslog(LOG_INFO, "Query is completed and found" . $query->num_rows. "rows");
		
				if($query->num_rows > 0 && $isHostedService ==0)
			   {
				   $return_data['reason']=2;
				   syslog(LOG_INFO, "Domain has unlicensed count so returning false for outlook plugin".$ret['status']);
				   return $return_data;
			   }
			   $query=$this->db->query("SELECT is_licensed FROM smtp_senders WHERE sender_address='".$username."'");
			   if($query->row['is_licensed'] == 0)
			   {
				   $return_data['reason']=3;
				   syslog(LOG_INFO, "EMPLOYEE is not licensed so returning false for outlook plugin".$ret['status']);
				   return $return_data;
			   }
			}
            return $ret;
        }
        
        
        $query = $this->db->query("SELECT u.username, u.uid, u.realname, u.dn, u.password, u.isadmin, u.domain, u.customer FROM " . TABLE_USER . " u, " . TABLE_EMAIL . " e WHERE e.email=? AND e.uid=u.uid AND u.status=1", array($username));
        
        if (!isset($query->row['password'])) {
            $return_data['primary_email']=$username;
            $return_data['status']=FALSE;
            $return_data['login_type']='local';
            
            return $return_data;
        }

        $pass = crypt($password, $query->row['password']);

        if ($pass == $query->row['password']) {
            $return_data['primary_email']=$username;
            $return_data['status']=TRUE;
			if(LICENSE_STATUS <> 'TRIAL_PERIOD' )
			{
			   list($l, $d) = explode("@", $username);
			   $current_date=date("m-d-Y");
	           $date = DateTime::createFromFormat("m-d-Y",$current_date);
	           $current_date = $date->format("Y-m-d");

                   if(LICENSE_STATUS == 'TRIAL_EXPIRED')
                     {
                        $return_data['reason']=4;
                        $return_data['status']=FALSE;
                        syslog(LOG_INFO, "Trial period has expired so returning false for outlook plugin".$ret['status']);
                        return $return_data;
                     }

                if(LICENSE_STATUS == 'GRACE_PERIOD_EXPIRED')
                     {
                        $return_data['reason']=5;
                        $return_data['status']=FALSE;
                        syslog(LOG_INFO, "Grace Period has so returning false for outlook plugin".$ret['status']);
                        return $return_data;
                     }

                if(LICENSE_STATUS == 'EXTEND_TRIAL_PERIOD_GRACE_PERIOD_EXPIRED')
                     {
                        $return_data['reason']=6;
                        $return_data['status']=FALSE;
                        syslog(LOG_INFO, "Extend trial period has expired so returning false for outlook plugin".$ret['status']);
                        return $return_data;
                     }

			   syslog(LOG_INFO, "Login for outlook plugin and verifying whether the domain of the user has unlicensed count and also the domain is ".$d);
			   $query=$this->db->query("SELECT id,domains,profile_grace_period_end_date from customers WHERE domains LIKE '%$d%' and profile_grace_period_end_date NOT IN('0000-00-00','NULL') and profile_grace_period_end_date < ? and is_deleted=?",array($current_date,0));
			   syslog(LOG_INFO, "Query is completed and found" . $query->num_rows. "rows");
			   if($query->num_rows > 0 && $isHostedService ==0)
			   {
				   syslog(LOG_INFO, "ldap is disabled and domain has unlicensed count so returning false for outlook plugin");
				   $return_data['status']=FALSE;
				   $return_data['reason']=2;
			   }
			   else
			   {
				 $query=$this->db->query("select isadmin from user where uid IN(select uid from email where `email`='$username')");
				if(!(($query->row['isadmin'] == 2) || ($query->row['isadmin'] == 3)))
				{
			      $query=$this->db->query("SELECT is_licensed FROM smtp_senders WHERE sender_address='".$username."'");
			      if($query->row['is_licensed'] == 0)
			      {
				   syslog(LOG_INFO, "ldap is disabled and EMPLOYEE is not licensed so returning false for outlook plugin");
				   $return_data['status']=FALSE;
				   $return_data['reason']=3;
			      }
			    }
			   }
			}
            $return_data['login_type']='local';
            
            return $return_data;
        }
        
        /*if($login_status == 1){
            return TRUE;
        }else{
            return FALSE;
        }*/
    }

    public function isEmployeeUser_outlook($username,$user_type){

       if($user_type == 'ldap'){
            $employee_user = 0;
            return $employee_user;
       }

        $query = $this->db->query("SELECT u.isadmin FROM " . TABLE_USER . " u, " . TABLE_EMAIL . " e WHERE e.email=? AND e.uid=u.uid AND u.status=1", array($username));

        return $query->row['isadmin'];

    }

    public function isEmployeeUser($username,$user_type){
        if($user_type == 'ldap'){
            return "true";
        }
        
        $query = $this->db->query("SELECT u.isadmin FROM " . TABLE_USER . " u, " . TABLE_EMAIL . " e WHERE e.email=? AND e.uid=u.uid AND u.status=1", array($username));
        
        if($query->row['isadmin'] == 2){
            return "false";
        }else{
            return "true";
        }
        
    }
    
    public function checkLoginAgainstLDAP_outlook($username, $password, $data, $a=array()){
        $return_data=array();
        if (count($a) >= 6) {
            $ldap_type = $a['ldap_type'];
            $ldap_host = $a['ldap_host'];
            $ldap_base_dn = $a['ldap_base_dn'];
            $ldap_helper_dn = $a['ldap_bind_dn'];
            $ldap_helper_password = $a['ldap_bind_pw'];
            $ldap_auditor_member_dn = $a['ldap_auditor_member_dn'];

            $ldap_mail_attr = $a['ldap_mail_attr'];
            $ldap_account_objectclass = $a['ldap_account_objectclass'];
            $ldap_distributionlist_attr = $a['ldap_distributionlist_attr'];
            $ldap_distributionlist_objectclass = $a['ldap_distributionlist_objectclass'];
            
        }
        
        $ldapconn = ldap_connect($a['ldap_host']);
        
        if ($ldapconn) {
            // binding to ldap server
            $ldapbind = ldap_bind($ldapconn, $username, $password);
            // verify binding
            if ($ldapbind) {
		$ldaptree = split(";",$ldap_base_dn);
                //$ldaptree = $ldap_base_dn;

		for($j=0;$j<sizeof($ldaptree);$j++){
                $filter="(userprincipalname=$username)";
                $justthese = array("ou", "sn", "givenname", "mail");

                $sr=ldap_search($ldapconn, $ldaptree[$j], $filter);

                $info = ldap_get_entries($ldapconn, $sr);
                //print_r($info["count"]);exit;
                for ($i=0; $i<$info["count"]; $i++) {
                    $return_data['primary_email']=$info[$i]["mail"][0];
                    $return_data['status']=TRUE;
                    $return_data['login_type']='ldap';
                }
		}
                if(isset($primary_email) && $primary_email == ""){
                    $return_data['primary_email']='';
                    $return_data['status']=FALSE;
                    $return_data['login_type']='ldap';
                }
            }
        }
        
        return $return_data;
    }

}

?>
